{smcl}
{* *! version 1.0  4nov2012}{...}
{viewerjumpto "Syntax" "fastxtile##syntax"}{...}
{viewerjumpto "Description" "fastxtile##description"}{...}
{viewerjumpto "Options" "fastxtile##options"}{...}
{viewerjumpto "Author" "fastxtile##author"}{...}
{viewerjumpto "Also see" "fastxtile##also-see"}{...}
{title:Title}

{p2colset 5 19 21 2}{...}
{p2col :{hi:fastxtile} {hline 2}}Drop in replacement for xtile, which runs significantly faster on large datasets{p_end}
{p2colreset}{...}

{marker syntax}{title:Syntax}

{phang}
Create variable containing quantile categories

{p 8 15 2}
{cmd:fastxtile}
{it:newvar} {cmd:=} {it:{help exp}}
{ifin}
{weight}
[{cmd:,} {it:options}]


{synoptset 22 tabbed}{...}
{synopthdr :options}
{synoptline}
{syntab :Main}
{synopt :{opt n:quantiles(#)}}number of quantiles; default is
{cmd:nquantiles(2)}{p_end}
{synopt :{opth c:utpoints(varname)}}use values of {it:varname} as cutpoints
{p_end}
{synopt :{opt alt:def}}use alternative formula for calculating
percentiles{p_end}

{syntab :Additions in fastxtile}
{synopt :{opth cutv:alues(numlist)}}use values of {it:numlist} as cutpoints; {it:numlist} must be strictly ascending{p_end}

{synopt :{opth randvar(varname)}}use {it:varname} to sample observations when computing quantile boundaries{p_end}
{synopt :{opt randcut(#)}}upper bound on {cmd:randvar()} used to cut the sample; default is {cmd:randcut(1)}{p_end}
{synoptline}

{p 4 6 2}
{opt aweight}s, {opt fweight}s, and {opt pweight}s are allowed
(see {manhelp weight U:11.1.6 weight}), except when
the {opt altdef} option is specified, in which case no weights are allowed.
{p_end}


{marker description}{...}
{title:Description}

{pstd}
{opt fastxtile} is a drop in replacement for {manhelp xtile D}.  It has the same
syntax and produces the same results, but has been optimized to run
significantly faster on large datasets.

{pstd}
It also supports computing the quantile boundaries using only a sample of the data.
This further increases the speed, but generates approximate quantiles due to sampling error.


{marker options}{...}
{title:Options}

{dlgtab:Main}

{phang}{opt nquantiles(#)} specifies the number of quantiles.
It computes percentiles corresponding to percentages 100*k/m
for k=1, 2, ..., m-1, where m={it:#}.  For example, {cmd:nquantiles(10)}
requests that the 10th, 20th, ..., 90th percentiles be computed.  The default
is {cmd:nquantiles(2)}; i.e., the median is computed.

{phang}{opt altdef} uses an alternative formula for calculating percentiles.
The default method is to invert the empirical distribution function by using
averages, where the function is flat (the default is the same method used by 
{cmd:summarize}; see {manhelp summarize R}).
The alternative formula uses an interpolation method.  Weights cannot be used
when {opt altdef} is specified.

{phang}{opth cutpoints(varname)} requests that {opt fastxtile}
use the values of {it:varname}, rather than quantiles, as cutpoints for the
categories.  All values of {it:varname} are used, regardless of any {opt if}
or {opt in} restriction. This option cannot be combined with any other options.

{dlgtab:Additions in fastxtile}

{phang}{opth cutvalues(numlist)} specifies a list of values to be used as
cutpoints for the categories.  The list must be ascending and contain no
repeated values. This option cannot be combined with any other options.

{phang}{opth randvar(varname)} requests that {it:varname} be used to select a
sample of observations when computing the quantile boundaries.  Sampling increases
the speed of {opt fastxtile}, but generates approximate quantiles due to sampling error.

{phang}{opt randcut(#)} specifies the upper bound on the variable contained
in {opt randvar(varname)}. Quantile boundaries are approximated using observations for which
{opt randvar()} <= #.  If no variable is specified in {opt randvar()},
a standard uniform random variable is used. The default is {cmd:randcut(1)}.


{marker author}{...}
{title:Author}

	Michael Stepner, michaelstepner@gmail.com
	
	The {cmd:fastxtile} code and documentation are based on the built-in xtile command.


{marker also-see}{...}
{title:Also see}

{psee}
Manual:  {manlink D pctile}

{psee}
{space 2}Help:  {manhelp pctile D}
{p_end}
